<?php
namespace Drupal\force_users_logout\Controller;
use Drupal\Core\Controller\ControllerBase;
use Symfony\Component\HttpFoundation\JsonResponse;
use Symfony\Component\HttpFoundation\Request;
use Drupal\Component\Utility\Tags;
use Drupal\Component\Utility\Unicode;
use Drupal\user\Entity\User;

/**
 * Defines a route controller for entity autocomplete form elements.
 */
 
class AutocompleteController extends ControllerBase {
  /**
   * Returns response for the autocompletion.
   *
   * @param \Symfony\Component\HttpFoundation\Request $request
   *   The current request object containing the search string.
   *
   * @return \Symfony\Component\HttpFoundation\JsonResponse
   *   A JSON response containing the autocomplete suggestions.
   */ 
  public function handleAutocomplete(Request $request) {
    $matches = array();
    $string = $request->query->get('q');
    if ($string) {
      $matches = array();
      $query = \Drupal::entityQuery('user')
               ->condition('status', 1)
               ->condition('name', '%'.db_like($string).'%', 'LIKE');
      $uids = $query->execute();
      $result = \Drupal::entityTypeManager()->getStorage('user')->loadMultiple($uids);
      foreach ($result as $row) {
        $matches[] = ['value' => $row->name->value . ' (' . $row->uid->value . ')', 'label' => $row->name->value];
      }
    }
    return new JsonResponse($matches);
  }
}