<?php
/**
 * @file
 * Contains Drupal\force_users_logout\Form\AllOtherUsersLogoutForm.
 */
namespace Drupal\force_users_logout\Form;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\user\Entity\User;
use Drupal\user\Entity\Role;

class AllOtherUsersLogoutForm extends ConfigFormBase {
  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'force_users_logout.allotherusers_logout_form',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'allotherusers_force_logout_form';
  }
 
  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state){
    $form = array();
    $roles = Role::loadMultiple();
    $optionarray[] = '';
    foreach($roles as $rolekey => $roleval){
      if($rolekey != 'administrator' && $rolekey != 'authenticated' && $rolekey != 'anonymous'){
        $optionsarray[$rolekey] = $roleval->label();
      }
    }
    $form['input_fields']['selectallogout'] = array(
      '#type' => 'checkboxes',
      '#options' => array("otherusers" => "Logout users other than admin"),
      '#title' => $this->t('This setting will force logout all users except admin'),
      '#default_value' => array(otherusers),
      '#required' => true,
    );
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Force Logout'),
    );
    return $form;
  }
 
  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    $selectedroles = array_filter($form_state->getValue('selectallogout'));
    if(!empty($selectedroles)){
      $query = \Drupal::entityQuery('user')
               ->condition('status', 1)
               ->condition('roles','administrator','<>')
               ->condition('roles','anonymous','<>');
      $uids = $query->execute();
      $result = \Drupal::entityTypeManager()->getStorage('user')->loadMultiple($uids);
      foreach($result as $user){
        \Drupal::currentUser()->setAccount($user);
          if (\Drupal::currentUser()->isAuthenticated()) {
            $session_manager = \Drupal::service('session_manager');
            $session_manager->delete(\Drupal::currentUser()->id());
          }
      }
      $this->messenger()->addStatus('All the users except admin role are logged out');
    }
  }
}