<?php
/**  
 * @file  
 * Contains Drupal\force_users_logout\Form\RoleBasedLogoutForm.  
 */  
namespace Drupal\force_users_logout\Form;
use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\user\Entity\User;
use Drupal\user\Entity\Role;

class RoleBasedLogoutForm extends ConfigFormBase {
  /**
   * {@inheritdoc}
   */
  protected function getEditableConfigNames() {
    return [
      'force_users_logout.rolebased_logout_form',
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'rolebased_force_logout_form';
  }
 
  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state){
    $form = array();
    $roles = Role::loadMultiple();
    $optionarray[] = '';
    foreach($roles as $rolekey => $roleval){
      if($rolekey != 'administrator' && $rolekey != 'authenticated' && $rolekey != 'anonymous'){
        $optionsarray[$rolekey] = $roleval->label();
      }
    }
    $form['input_fields']['selectrole'] = array(
      '#type' => 'checkboxes',
      '#options' => $optionsarray,
      '#title' => $this->t('Select the roles'),
      '#required' => true,
    );
    $form['submit'] = array(
      '#type' => 'submit',
      '#value' => t('Submit'),
    );
    return $form;
  }
 
  /**
   * {@inheritdoc}
   */
  public function submitForm(array &$form, FormStateInterface $form_state) {
    parent::submitForm($form, $form_state);
    $selectedroles = array_filter($form_state->getValue('selectrole'));
    $loggedoutroles = '';
    foreach($selectedroles as $selectedrole){
      $query = \Drupal::entityQuery('user')
               ->condition('status', 1)
               ->condition('roles', $selectedrole);
      $uids = $query->execute();
      $result = \Drupal::entityTypeManager()->getStorage('user')->loadMultiple($uids);
        foreach($result as $user){
          \Drupal::currentUser()->setAccount($user);
          if (\Drupal::currentUser()->isAuthenticated()) {
            $session_manager = \Drupal::service('session_manager');
            $session_manager->delete(\Drupal::currentUser()->id());
          }
        }
    }
    $this->messenger()->addStatus('The users belonged to the selected roles have been Logged out.');
  }
}